=== doc/typst/CMakeLists.txt ===
if(USE_TYPST)
    set(USETYPST_DEFAULT_ALL_TARGET ON)

    message("\n${BoldGreen}Build typst documentation ${PROJECT_NAME}${ColourReset}\n")
    include(${LOCAL_CMAKE_MODULE_PATH}/UseTYPST.cmake)
    add_typst_document(psmcbor_documentation psmcbor/psmcbordoc.typ)
    add_typst_document(masschroq_documentation mcq/main.typ)
    add_typst_document(mzcbor_documentation mzcbor/mzcbordoc.typ)
endif(USE_TYPST)
