=== tests/pappsotree/CMakeLists.txt ===


# These source files are compiled into a single Catch2-based test binary.
# tests dedicated to check speed performances (benchmarks)
set(catch2_only_cpp_pappsotree_SRCS
    test_cborpsm.cpp
    test_cborpsm2json.cpp
    test_cbormzid.cpp
    test_cborsage.cpp
    test_fasta_reader.cpp
    test_msrun.cpp
    test_msrunalignment.cpp
    test_msrunreaderng_tims.cpp
    test_msrunreaderng.cpp
    test_mzcbor.cpp
    test_tims_dda.cpp
    test_tims_dia.cpp
   # test_tims_dia_micro.cpp
   # test_tims_dia_micro_slice.cpp
   # test_tims_dia_nano.cpp
    test_tims_data_xic_chromatogram.cpp
    test_tims_ion_mobility_grid.cpp
    test_mzcbor_xicextractor.cpp
    test_timsframe.cpp
    test_xicextractor.cpp
  )

add_executable(catch2-only-pappsotree
    ../common.cpp
    ${catch2_only_cpp_pappsotree_SRCS}
  )

get_target_property(INCLUDE_DIRS catch2-only-pappsotree INTERFACE_INCLUDE_DIRECTORIES)
message("Include directories for catch2-only-pappsotree: ${INCLUDE_DIRS}")


target_link_libraries(catch2-only-pappsotree
    ${required_target_link_libraries})


target_include_directories(catch2-only-pappsotree PUBLIC
      ${CMAKE_BINARY_DIR}/tests

    ${CMAKE_BINARY_DIR} # so that #include "config.h" works and #include "tests/tests-config.h" works also
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2
    Catch2::Catch2WithMain
    )
