=== tests/peptidoms/CMakeLists.txt ===
# These source files are compiled into a single Catch2-based test binary.
# tests dedicated to check speed performances (benchmarks)
set(catch2_only_cpp_peptidoms_SRCS  test_peptidoms.cpp test_fine_4291.cpp test_zea_4291.cpp test_zea_8119.cpp test_diff_java.cpp)

if(USE_PAPPSO_TREE)
    set(catch2_only_cpp_peptidoms_pappsotree_SRCS test_double.cpp test_precise_align.cpp test_zea_4512.cpp test_zea_4542.cpp)
endif(USE_PAPPSO_TREE)

add_executable(
    catch2-only-peptidoms
    ${catch2_only_cpp_peptidoms_SRCS} ${catch2_only_cpp_peptidoms_pappsotree_SRCS} ../common.cpp
)

get_target_property(INCLUDE_DIRS catch2-only-peptidoms INTERFACE_INCLUDE_DIRECTORIES)
message("Include directories for catch2-only-peptidoms: ${INCLUDE_DIRS}")

target_include_directories(
    catch2-only-peptidoms
    PUBLIC
    ${CMAKE_BINARY_DIR} # so that #include "config.h" works and #include "tests/tests-config.h" works also
    ${PappsoMSpp_INCLUDE_DIRS}
    Catch2::Catch2
    Catch2::Catch2WithMain
)

target_link_libraries(
    catch2-only-peptidoms ${required_target_link_libraries}
)
