=== src/pappsomspp/core/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)
# Major rework of the whole project structure, Filippo Rusconi, summer 2025

message("\n${BoldGreen}Now configuring src/core for ${PROJECT_NAME}${ColourReset}\n")

add_definitions(-DWITHOUT_MZ5)

########################################################
# Files
set(CPP_FILES
    types.cpp
    utils.cpp
    mzrange.cpp
    precision.cpp
    amino_acid/aa.cpp
    amino_acid/aabase.cpp
    amino_acid/aacode.cpp
    amino_acid/aamodification.cpp
    amino_acid/aastringcodec.cpp
    amino_acid/aastringcodemassmatching.cpp
    amino_acid/atomnumberinterface.cpp
    amino_acid/chemicalformula.cpp
    massspectrum/massspectrumid.cpp
    massspectrum/massspectrum.cpp
    massspectrum/qualifiedmassspectrum.cpp
    fasta/fastafileindexer.cpp
    fasta/fastareader.cpp
    fasta/fastaoutputstream.cpp
    grouping/grpexperiment.cpp
    grouping/grppeptide.cpp
    grouping/grpprotein.cpp
    grouping/grpgroup.cpp
    grouping/grpsubgroup.cpp
    grouping/grppeptideset.cpp
    grouping/grpmappeptidetogroup.cpp
    grouping/grpmappeptidetosubgroupset.cpp
    grouping/grpsubgroupset.cpp
    grouping/grpgroupingmonitor.cpp
    masschroq/input/jsoninput.cpp
    masschroq/input/precursorparser.cpp
    masschroq/output/cboroutputstream.cpp
    masschroq/alignmentmethod.cpp
    masschroq/mbrpeptidemeasurements.cpp
    masschroq/msrun.cpp
    masschroq/msrungroup.cpp
    masschroq/msrunpeptidelist.cpp
    masschroq/peptide.cpp
    masschroq/peptidebase.cpp
    masschroq/peptidelabel.cpp
    masschroq/peptidemeasurements.cpp
    masschroq/peptidemeasurementsbase.cpp
    masschroq/peptideobservation.cpp
    masschroq/precursor.cpp
    masschroq/protein.cpp
    masschroq/quantificationmethod.cpp
    masschroq/utils.cpp
    msfile/msfileaccessor.cpp
    msfile/msfilereader.cpp
    msfile/mzcbormsfilereader.cpp
    msfile/mzformatenumstr.cpp
    msfile/pwizmsfilereader.cpp
    msfile/timsmsfilereader.cpp
    msfile/xymsfilereader.cpp
    msfile/bafasciifilereader.cpp
    msrun/spectrumcollectionhandlerinterface.cpp
    msrun/alignment/msrunretentiontime.cpp
    msrun/alignment/template.cpp
    msrun/output/mzxmloutput.cpp
    msrun/output/mgfoutput.cpp
    msrun/msrundatasettreenode.cpp
    msrun/msrundatasettree.cpp
    msrun/msrunid.cpp
    msrun/msrunreader.cpp
    msrun/msrunreadconfig.cpp
    msrun/private/mzcbormsrunreader.cpp
    msrun/private/pwizmsrunreader.cpp
    msrun/private/timsmsrunreader.cpp
    msrun/private/timsmsrunreaderbase.cpp
    msrun/private/timsmsrunreaderdia.cpp
    msrun/private/timsframesmsrunreader.cpp
    msrun/private/timsmsrunreaderms2.cpp
    msrun/private/timsmsrunreaderms2selected.cpp
    msrun/xiccoord/ionmobilitygrid.cpp
    msrun/xiccoord/xiccoord.cpp
    msrun/xiccoord/xiccoordtims.cpp
    msrun/xymsrunreader.cpp
    msrun/bafasciimsrunreader.cpp
    obo/filterobopsimodmap.cpp
    obo/filterobopsimodsink.cpp
    obo/filterobopsimodtermaccession.cpp
    obo/filterobopsimodtermdiffmono.cpp
    obo/filterobopsimodtermlabel.cpp
    obo/filterobopsimodtermname.cpp
    obo/obopsimod.cpp
    obo/obopsimodterm.cpp
    obo/obopsims.cpp
    obo/obounimod.cpp
    peptide/ion.cpp
    peptide/peptideinterface.cpp
    peptide/peptide.cpp
    peptide/peptidefragment.cpp
    peptide/peptidefragmention.cpp
    peptide/peptidefragmentionlistbase.cpp
    peptide/peptidenaturalisotope.cpp
    peptide/peptidenaturalisotopelist.cpp
    peptide/peptidenaturalisotopeaverage.cpp
    peptide/peptideproformaparser.cpp
    peptide/peptiderawfragmentmasses.cpp
    peptide/peptidestrparser.cpp
    processing/cbor/cborstreamreader.cpp
    processing/cbor/cborstreamreaderinterface.cpp
    processing/cbor/cborstreamwriter.cpp
    processing/cbor/jsonstreamwriter.cpp
    processing/cbor/mzcbor/binarydataarray.cpp
    processing/cbor/mzcbor/converttomzml.cpp
    processing/cbor/mzcbor/cvparam.cpp
    processing/cbor/mzcbor/cvparammap.cpp
    processing/cbor/mzcbor/mzcborbuildindexreader.cpp
    processing/cbor/mzcbor/mzcborindexreader.cpp
    processing/cbor/mzcbor/mzcborspectrumcollectionreader.cpp
    processing/cbor/mzcbor/mzcborreaderbase.cpp
    processing/cbor/mzcbor/mzmlconvert.cpp
    processing/cbor/mzcbor/precursor.cpp
    processing/cbor/mzcbor/scan.cpp
    processing/cbor/mzcbor/spectrum.cpp
    processing/cbor/psm/cborscanmapbase.cpp
    processing/cbor/psm/psmcbor2json.cpp
    processing/cbor/psm/psmcborutils.cpp
    processing/cbor/psm/psmfileappend.cpp
    processing/cbor/psm/psmfilereaderbase.cpp
    processing/cbor/psm/psmfilescanprocess.cpp
    processing/cbor/psm/psmfilescanprocessandcopy.cpp
    processing/cbor/psm/psmproteinmap.cpp
    processing/cbor/psm/evalscan/psmfeatures.cpp
    processing/cbor/psm/evalscan/psmfeaturesscan.cpp
    processing/cbor/psm/evalscan/psmionseries.cpp
    processing/cbor/psm/evalscan/psmspecglob.cpp
    processing/cbor/psm/evalscan/psmspecglobscan.cpp
    processing/cbor/psm/evalscan/psmspecpeptidoms.cpp
    processing/cbor/psm/mzidentml/mzidentmlreader.cpp
    processing/cbor/psm/sage/sagefilereader.cpp
    processing/cbor/psm/sage/sagereader.cpp
    processing/cbor/psm/sage/sagetsvhandler.cpp
    processing/combiners/mzintegrationparams.cpp
    processing/combiners/integrationscopebase.cpp
    processing/combiners/integrationscope.cpp
    processing/combiners/integrationscoperect.cpp
    processing/combiners/integrationscoperhomb.cpp
    processing/combiners/selectionpolygon.cpp
    processing/combiners/tracecombiner.cpp
    processing/combiners/traceminuscombiner.cpp
    processing/combiners/tracepluscombiner.cpp
    processing/combiners/massdatacombinerinterface.cpp
    processing/combiners/massspectrumcombiner.cpp
    processing/combiners/massspectrumpluscombiner.cpp
    processing/combiners/massspectrumminuscombiner.cpp
    processing/compartraces/cosinesimilarity.cpp
    processing/detection/tracedetectionzivy.cpp
    processing/detection/tracedetectionmoulon.cpp
    processing/detection/tracepeak.cpp
    processing/detection/tracepeaklist.cpp
    processing/detection/cubicsplinemodel.cpp
    processing/detection/localsignaltonoiseestimator.cpp
    processing/detection/highrespeakpicker.cpp
    processing/filters/filterchargedeconvolution.cpp
    processing/filters/filtercomplementionenhancer.cpp
    processing/filters/filterexclusionmz.cpp
    processing/filters/filterlocalmaximum.cpp
    processing/filters/filtermorpho.cpp
    processing/filters/filternameinterface.cpp
    processing/filters/filterpass.cpp
    processing/filters/filterpeakdelta.cpp
    processing/filters/filterremovec13.cpp
    processing/filters/filterresample.cpp
    processing/filters/filtersuite.cpp
    processing/filters/filtersuitestring.cpp
    processing/filters/filtertandemremovec13.cpp
    processing/filters/filtertriangle.cpp
    processing/filters/savgolfilter.cpp
    processing/filters/filterflooramplitudepercentage.cpp
    processing/filters/filterceilingamplitudepercentage.cpp
    processing/filters/filterlowintensitysignalremoval.cpp
    processing/filters/filternormalizeintensities.cpp
    processing/project/projectparameters.cpp
    processing/specglob/experimentalspectrum.cpp
    processing/specglob/peptidemodel.cpp
    processing/specglob/peptidespectrum.cpp
    processing/specglob/posttreatment.cpp
    processing/specglob/scorevalues.cpp
    processing/specglob/spectralalignment.cpp
    processing/specpeptidoms/correctiontree.cpp
    processing/specpeptidoms/locationsaver.cpp
    processing/specpeptidoms/peptidemodel.cpp
    processing/specpeptidoms/scenario.cpp
    processing/specpeptidoms/scorevalues.cpp
    processing/specpeptidoms/semiglobalalignment.cpp
    processing/specpeptidoms/spomsprotein.cpp
    processing/specpeptidoms/spomsspectrum.cpp
    processing/specself/selfspectrum.cpp
    processing/specself/selfspectrumdatapoint.cpp
    processing/spectree/bucket.cpp
    processing/spectree/bucketclustering.cpp
    processing/spectree/itemcart.cpp
    processing/spectree/spectree.cpp
    processing/spectree/specxtractinterface.cpp
    processing/tandemwrapper/tandemwrapperrun.cpp
    processing/tandemwrapper/wraptandeminput.cpp
    processing/tandemwrapper/wraptandemresults.cpp
    processing/tandemwrapper/xtandempresetreader.cpp
    processing/uimonitor/uimonitortext.cpp
    processing/uimonitor/uimonitortextpercent.cpp
    processing/xml/mzidentmlwriter.cpp
    processing/xml/xmlstreamreaderinterface.cpp
    protein/enzyme.cpp
    protein/peptidesizefilter.cpp
    protein/peptidebuilder.cpp
    protein/peptidevariablemodificationbuilder.cpp
    protein/peptidevariablemodificationreplacement.cpp
    protein/peptidefixedmodificationbuilder.cpp
    protein/peptidemodificatorbase.cpp
    protein/peptidemodificatortee.cpp
    protein/peptidemethioninremove.cpp
    protein/peptidemodificatorpipeline.cpp
    protein/peptidesemienzyme.cpp
    protein/protein.cpp
    protein/proteinintegercode.cpp
    protein/proteinpresenceabsencematrix.cpp
    psm/deepprot/deepprotenum.cpp
    psm/experimental/ionisotoperatioscore.cpp
    psm/features/psmfeatures.cpp
    psm/morpheus/morpheusscore.cpp
    psm/peakionmatch.cpp
    psm/peakionisotopematch.cpp
    psm/peptidespectrummatch.cpp
    psm/peptideisotopespectrummatch.cpp
    psm/xtandem/xtandemhyperscore.cpp
    psm/xtandem/xtandemhyperscorebis.cpp
    psm/xtandem/xtandemspectrumprocess.cpp
    trace/datapoint.cpp
    trace/linearregression.cpp
    trace/maptrace.cpp
    trace/trace.cpp
    vendors/tims/mobilitytraces/timsframemobilitytraces.cpp
    vendors/tims/mzcalibration/cardano.cpp
    vendors/tims/mzcalibration/mzcalibrationinterface.cpp
    vendors/tims/mzcalibration/mzcalibrationmodel1.cpp
    vendors/tims/mzcalibration/mzcalibrationstore.cpp
    vendors/tims/xicextractor/timsdirectxicextractor.cpp
    vendors/tims/xicextractor/timsxicextractorinterface.cpp
    vendors/tims/timsbindec.cpp
    vendors/tims/timsdata.cpp
    vendors/tims/timsdatafastmap.cpp
    vendors/tims/timsddaprecursors.cpp
    vendors/tims/timsdiaslices.cpp
    vendors/tims/timsframe.cpp
    vendors/tims/timsframerawdatachunck.cpp
    vendors/tims/timsframebase.cpp
    vendors/tims/timsframetype1.cpp
    vendors/tims/timsms2centroidfilter.cpp
    xic/xic.cpp
    xic/qualifiedxic.cpp
    xic/xicpeptideinterface.cpp
    xic/xicpeptidefragmention.cpp
    xic/xicpeptidefragmentionnaturalisotope.cpp
    xicextractor/private/msrunslice.cpp
    xicextractor/private/msrunxicextractor.cpp
    xicextractor/private/msrunxicextractordisk.cpp
    xicextractor/private/msrunxicextractordiskbuffer.cpp
    xicextractor/msrunxicextractorfactory.cpp
    xicextractor/msrunxicextractorinterface.cpp
    #
    # Scripting
    js_qml/jsclassregistrar.cpp
    js_qml/pappsojsqml.cpp
    js_qml/datapointjs.cpp
    js_qml/qpointfjs.cpp
    js_qml/tracejs.cpp
    js_qml/massspectrumjs.cpp
)

# generate rules for building source files from the resources
# and the JS reference text also.
qt6_add_resources(QRC_SRCS libpappsomspp_core_resources.qrc)

message("Generated the following resource files: ${QRC_SRCS}")

file(
    GLOB_RECURSE Core_HEADERS
    LIST_DIRECTORIES false
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    "*.h"
)
message(STATUS "Core header files: ${Core_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

#############################################################
# Build the static lib
add_library(
    Core_static STATIC
    ${Core_HEADERS} ${CPP_FILES} ${QRC_SRCS}
)

# So that the JavaScript reference text is extracted before using
# libpappsomspp_core_resources.qrc that reference it.
add_dependencies(Core_static extract_class_js_ref_text)

set_target_properties(
    Core_static
    PROPERTIES EXPORT_NAME "Core_static"
               OUTPUT_NAME pappsomspp-core
               CLEAN_DIRECT_OUTPUT 1
               LINK_FLAGS "-Wl,--whole-archive"
)
