=== debian/changelog ===
libpappsomspp (0.11.10-1) unstable; urgency=medium

  [Rusconi]
  * New upstream release with new code to estimate noise and pick peaks.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 17 Feb 2026 14:56:28 +0100
